# std::owner_less

From cppreference.com
< cpp‎ | memory

Defined in header `<memory>` |  |
template<> struct owner_less<void>; |  | (since C++17)

std::owner_less<> is a specialization of std::owner_less with parameter types deduced.

### Member types

Member type | Definition
`is_transparent` | /* unspecified */

### Notes

The member type `is_transparent` indicates to the caller that this function object is a transparent function object: it accepts arguments of arbitrary types and uses perfect forwarding, which avoids unnecessary copying and conversion when the function object is used in heterogeneous context, or with rvalue arguments. In particular, template functions such as std::set::find and std::set::lower_bound make use of this member type on their `Compare` types.

### Member functions

operator() | compares its arguments using owner-based semantics (function)

## std::owner_less<void>::operator()

template<class T, class U> bool operator()( const std::shared_ptr<T>& lhs, const std::shared_ptr<U>& rhs ) const; |  | (since C++17)
template<class T, class U> bool operator()( const std::shared_ptr<T>& lhs, const std::weak_ptr<U>& rhs ) const; |  | (since C++17)
template<class T, class U> bool operator()( const std::weak_ptr<T>& lhs, const std::shared_ptr<U>& rhs ) const; |  | (since C++17)
template<class T, class U> bool operator()( const std::weak_ptr<T>& lhs, const std::weak_ptr<U>& rhs ) const; |  | (since C++17)

Compares `lhs` and `rhs` using owner-based semantics. Effectively calls lhs.owner_before(rhs).

The ordering is strict weak ordering relation.

`lhs` and `rhs` are equivalent only if they are both empty or share ownership.

### Parameters

lhs, rhs | - | shared-ownership pointers to compare

### Return value

true if `lhs` is less than `rhs` as determined by the owner-based ordering.

### Exceptions

`noexcept` specification:
noexcept

### See also

owner_before | provides owner-based ordering of shared pointers (public member function of `std::shared_ptr`)
owner_before | provides owner-based ordering of weak pointers (public member function of `std::weak_ptr`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/owner_less_void&oldid=91724"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template